#ifndef REVERSI_CONTROLLER_H_INCLUDED
#define REVERSI_CONTROLLER_H_INCLUDED

#include "board.h"
#include "statusdisplay.h"
#include "com.h"

//=============================================================================
// bZ[W̏ƂAQ[̐isƂNX
//=============================================================================
class Controller {
public:
	// RXgN^
	Controller(HWND hWnd);

	// fXgN^
	~Controller();

	// `揈
	void onPaint(HWND hWnd);

	// NbN
	void onLButtonUp(HWND hWnd, int x, int y);

	// R}h
	void onCommand(HWND hWnd, int id, HWND hwndCtrl);

private:
	void onPut(HWND hWnd);
	void onGameOver(HWND hWnd);
	bool canPut();

private:
	Board* board;
	StatusDisplay* statusDisplay;
	int turn;
	bool gameover;
	ICom* com;

	HBITMAP hBufferBitmap;  // _uobt@Oprbg}bv
	HDC hBufferDC;          // _uobt@OpDC

};

#endif
