#ifndef REVERSI_DISC_H_INCLUDED
#define REVERSI_DISC_H_INCLUDED

//=============================================================================
// 
// 2̃CX^X(΁C)݂Ȃ
//=============================================================================
class Disc {
public:
	// ΂擾
	static Disc* black() { return &black_; }

	// ΂擾
	static Disc* white() { return &white_; }

	// ԂꂽdiscԂ
	static Disc* getReversed(const Disc* disc) {
		if (disc == &black_) return &white_;
		if (disc == &white_) return &black_;
		return NULL;
	}

	// ɕϊ
	static LPCTSTR toString(const Disc* disc) {
		if (disc == &black_) return TEXT("");
		if (disc == &white_) return TEXT("");
		return TEXT("Q");
	}

private: 
	// RXgN^͎gps
	Disc() {}

private:
	static Disc black_;  // ΂̃CX^X
	static Disc white_;  // ΂̃CX^X
};

#endif
