#ifndef REVERSI_STATUSDISPLAY_H_INCLUDED
#define REVERSI_STATUSDISPLAY_H_INCLUDED

#include "board.h"
#include "com.h"

//=============================================================================
// ԕ\
//=============================================================================
class StatusDisplay {
public:
	// 
	static const int WIDTH  = 150;
	// 
	static const int HEIGHT = 140;
	// gƕƂ̊Ԃ̗]̕
	static const int PADDING = 10;

	// RXgN^
	StatusDisplay(int x, int y, const Board* board);

	// ԂXV
	void update(int turn, ICom* com, bool gameover = false, Disc* win = NULL);

	// `悷
	void draw(HDC hdc);

private:
	int x, y;
	int turn;
	const Board* board;
	ICom* com;

	Disc* win;
	bool gameover;
};

#endif
